<?php
##############################################################################
# G5-Scripts.de PHP Newsletter Script
# Copyright 2004-2013 G5-Scripts.de webmaster@G5-Scripts.de
# Last Modified                04.01.2013
# G5-Scripts.de                http://www.G5-Scripts.de
# Version                      1.2.7
##############################################################################
# Lizenzbedingungen (gekürzte Fassung)
# Copyright 2004-2013 G5-Scripts.de  All Rights Reserved.
# 
# Mit dem Herunterladen bzw. Erwerb der hier angebotenen Software erkennen die Nutzer 
# ausdrücklich die Lizenzbestimmungen gelesen und diese anerkannt zu haben.
#
# Beim Einsatz der Software im rein privaten Bereich ohne kommerzielle oder gewerbliche Absicht, 
# ist die Software für die Nutzung kostenfrei. Für die kommerzielle Nutzung sowie 
# eine optionale Entfernung des Copyright Hinweises ist eine geeignete Lizenz zu erwerben.
#
# Diese Software darf im rein privaten Bereich frei benutzt werden, 
# solange alle Copyright bzw. Powered By Verweise auf G5-Scripts.de, 
# eingebaut innerhalb der Software, erhalten bleibt. Diese müssen für Benutzer sichtbar sein 
# und in unveränderter Form dargestellt werden.
#
# Die Original-Software unver&auml;ndert darf weitergegeben, jedoch nicht verkauft
# oder wiederverkauft werden.
# Die angepasste bzw. ver&auml;nderte Software und Teile dieser d&uuml;rfen nicht
# weitergegeben, verkauft oder wiederverkauft werden.
#
# Die vollständige Fassung der Lizenzbedingungen finden Sie unter:
# http://www.g5-scripts.de/scripte__newsletter_php__lizenzbedingungen.htm
#
##############################################################################


class NSLetter
{
    private $entityPath;
    private $doc;

    public $id;
    public $date;
    public $time;
	public $categorie = array();
	public $format = "text";
	public $subject = "";
	public $message = "";
	public $header = "";
	public $footer = "";
	
	
    
    public function __construct($entityPath, $id)
    {
		$id = (int)$id;
        $this->doc = new DOMDocument('1.0', 'UTF-8');
        $this->doc->formatOutput = true; 
        $this->doc->appendChild($this->doc->createElement('Letter'));

        $this->id = $id;
        $this->entityPath = $entityPath."/".$this->id;

		date_default_timezone_set('Europe/Berlin');
		
        $this->date = date("d.m.Y", $id);
		$this->time  = date("H:i", $id);
    }
    
    public function Load()
    {
        $entityFile = $this->entityPath;
        
        if(file_exists($entityFile)){
            @$ret = $this->doc->load($entityFile);
            
            if($ret){
                //ist XML
				$this->categorie = explode('|', $this->getValue("Categorie"));
				$this->format    = $this->getValue("Format");
				$this->subject   = $this->getValue("Subject");
				$this->message   = $this->getValue("Message");
				$this->header	 = $this->getValue("Header");
				$this->footer    = $this->getValue("Footer");
                
                return true;
            }else{
                //hat nicht geklappt, scheint noch altes format zu sein
                $inhalt        = file($entityFile);

				$this->categorie = explode('|', trim($inhalt[1]));
				$this->format    = trim($inhalt[2]);
				$this->subject   = trim($inhalt[3]);
				$this->message   = trim(implode("",array_slice($inhalt,4,count($inhalt))));

				$this->Save();
				
                return true;
            }
        }
        
        return false;
    }
    public function Save()
    {
        $entityFile = $this->entityPath;
		
		$this->setValue("Categorie",	implode('|', $this->categorie));
		$this->setValue("Format",		$this->format);
		$this->setValue("Subject",		$this->subject);
		$this->setValue("Message",		$this->message);
		$this->setValue("Header",		$this->header);
		$this->setValue("Footer",		$this->footer);

        $this->doc->save($entityFile);
		@chmod($entityFile, 0644);
    }
    
	public function IsHTML(){return $this->format == "html" ? true : false;}
	public function IsText(){return $this->format == "text" ? true : false;}

    private function getValue($tagName){
        $val = "";
        $node = $this->doc->getElementsByTagName($tagName)->item(0);
        if($node != null){
			$val = trim($node->nodeValue);
        }
        return $val;
    }
    private function setValue($tagName, $value){
		$root = $this->doc->getElementsByTagName("Letter")->item(0);
        $node = $this->doc->getElementsByTagName($tagName)->item(0);
        $value = trim($value, "\n");
        $value = trim($value, "\r");
        $value = trim($value, "\t");
		$value = $this->_convert($value);
        $value = $this->doc->createCDATASection($value);
		
        if($node != null){
			$root->removeChild($node);
		}
            
        $newNode = $this->doc->createElement($tagName);
        $newNode->appendChild($value);
        
        $root->appendChild($newNode);
    }
	
	private function _convert($content) {
		if(!mb_check_encoding($content, 'UTF-8') OR !($content === mb_convert_encoding(mb_convert_encoding($content, 'UTF-32', 'UTF-8' ), 'UTF-8', 'UTF-32'))) {
			$content = mb_convert_encoding($content, 'UTF-8');
		}
		return $content;
	}
}

?>