﻿//##############################################################################
//# G5-Scripts.de PHP Newsletter Script - Template Plugin
//# Copyright 2004-2012 G5-Scripts.de webmaster@G5-Scripts.de
//# Last Modified                25.07.2012
//# G5-Scripts.de                http://www.G5-Scripts.de
//# Version                      1.0
//##############################################################################
//# COPYRIGHT Bestimmungen
//# Copyright 2004-2012 G5-Scripts.de  All Rights Reserved.
//#
//# Dieser Code stellt eine Erweiterung für das Hauptprogramm „Newsletter PHP“ 
//# von G5-Scripts.de bereit. 
//# Dieser Code kann und darf nur im Zusammenhang mit dem 
//# Hauptprogramm „Newsletter PHP“ genutzt werden.
//# 
//##############################################################################
$(document).ready(function() {
    //javaScript test
    $('#jQueryTest').hide();

    $('#einbaumoeglichkeiten').hide();

    $('#einbaumoeglichkeitenLink').css('cursor', 'pointer');
    $('#einbaumoeglichkeitenLink').click(function() {
        if ($('#einbaumoeglichkeiten').css('display') == 'none') {
            $('#einbaumoeglichkeiten').fadeIn('slow');
        } else {
            $('#einbaumoeglichkeiten').fadeOut('slow');
        }
    });

    //test newsletter an admin
    $('#sendToAdmin').click(function() {
        var subject = $('#betreff').val().trim();
        var content = (window.tinyMCE === undefined || tinyMCE.get('mailtext') === undefined) ? $('#mailtext').val() : tinyMCE.get('mailtext').getContent();

        if (subject.length == 0) {
            alert("Bitte geben Sie einen Betreff ein!");
            $('#betreff').focus();
            return;
        }

        $('#sendToAdmin').attr('disabled', true);

        var url = NSL.getMainDirURL() + "/admin.php";
        $.post(url, { 'ac': 'send_letter_admin', 'betreff': subject, 'mailtext': content },
                    function(response) {
                        alert(response);
                        $('#sendToAdmin').removeAttr('disabled');
                    });
    });

    //newsletter an user
    $('#sendToUser').click(function() {
        var subject = $('#betreff').val().trim();
        var content = (window.tinyMCE === undefined || tinyMCE.get('mailtext') === undefined) ? $('#mailtext').val() : tinyMCE.get('mailtext').getContent();
        var selCats = $('#categorie').find('option:selected');

        var cats = [];
        var nslID = 0;
        if (selCats.length > 0) {
            selCats.each(function() {
                var val = $(this).val();
                cats.push(val);
            });
        }

        if (subject.length == 0) {
            alert("Bitte geben Sie einen Betreff ein!");
            $('#betreff').focus();
            return;
        }

        $('#sendToUser').attr('disabled', true);

        var url = NSL.getMainDirURL() + "/admin.php";

        //erst newsletter speichern
        $.post(url, { 'ac': 'saveLetter', 'betreff': subject, 'mailtext': content, "categorie": cats },
                    function(response) {
                        if (response.length > 0) {
                            //newsletter erfolgreich gespeichert -> antwort beinhaltet alle empfänger
                            var rows = response.split("\n");            //zeilenweise
                            if (rows[rows.length - 1].length == 0)
                                rows.pop();                             //letztes element ist leer

                            if (rows.length > 0) {                      //haben auch mind. 1 empfänger
                                //container mit den kategorien ausblenden und dafür einen progress container einblenden
                                var parent = $('#nslContainerSendToUser').parent();

                                var counter = $('<div></div>')
                                    .attr('id', 'nslProgressCounter')
                                    .text('0/0')
                                    .css('float', 'right');

                                var caption = $('<div></div>')
                                    .addClass('caption')
                                    .text('Newsletter wird versendet...')
                                    .append(counter);

                                var box = $('<div></div>')
                                    .attr('id', 'nslProgressBox')
                                    .css('height', '135px')
                                    .css('overflow-y', 'scroll');

                                var newBox = $('#nslContainerSendToUser').clone()
                                    .attr('id', 'nslProgress')
                                    .empty()
                                    .append(caption)
                                    .fadeOut(1)
                                    .append(box);

                                $('#nslContainerSendToUser').fadeOut(function() {
                                    parent.append(newBox);
                                    newBox.fadeIn()

                                    counter.attr('total', rows.length)
                                           .text('0/' + rows.length);

                                    //alle empfänger gleich in die progessbox einfügen, mit einem loading bildchen und state="0" (0 = unversenden, 1 = versendet)
                                    while (rows.length > 0) {
                                        var row = rows.shift();
                                        var elems = row.split('|');
                                        if (elems.length >= 2) {
                                            var catID = elems[0];
                                            var email = elems[1];
                                            var nslID = elems[2];

                                            box.append('<span class="Loading16" catID="' + catID + '" nslID="' + nslID + '" state="0" style="display: block;">' + email + '</span>');
                                        }
                                    }

                                    //versand anstarten
                                    sendMails();
                                });

                            }
                        } else {
                            alert("In den ausgewählten Kategorien sind noch keine Abonnenten vorhanden!");
                            $('#sendToUser').removeAttr('disabled');
                        }
                    });
    });

    function sendMails() {
        var entities = $('#nslProgressBox').find('span[catID!=""][state="0"]');
        var counter = $('#nslProgressCounter');
        var total = counter.attr('total');

        if (entities.length == 0) {
            if (total > 0) {
                alert('Fertig!\nIhr Newsletter wurde an ' + total + ' Abonnenten verschickt!');

                $('#nslProgress').fadeOut(function() {
                    $('#nslContainerSendToUser').fadeIn();
                    $('#sendToUser').attr('disabled', false);

                    $('#nslProgress').parent().remove('#nslProgress');
                });
            }
            return;
        }

        var first = entities.first();
        var catID = first.attr('catID');
        var nslID = first.attr('nslID');
        var email = first.text();

        counter.text((total - entities.length + 1) + '/' + total);

        var url = NSL.getMainDirURL() + "/admin.php";
        $.post(url, { 'ac': 'send_letter_user', 'email': email, 'cat': catID, "nslID": nslID },
                    function(response) {
                        if (response.length > 0) {
                            var elems = response.split('|');
                            if (elems.length == 4) {
                                var catID = elems[0];
                                var email = elems[1];
                                var nslID = elems[2];
                                var state = elems[3];

                                var entity = $('#nslProgressBox').find('span[catID!=""][state="0"][catID="' + catID + '"][nslID="' + nslID + '"]:contains(' + email + ')');
                                if (entity.length > 0) {
                                    entity.attr('state', '1');
                                    if (state == "1")
                                        entity.attr('class', 'Accept16');
                                    else
                                        entity.attr('class', 'Cancel16');

                                    $('#nslProgressBox').scrollTop(entity.index() * entity.height());
                                }
                            }
                        }
                    }).error(function() {
                        alert('Es ist ein Fehler aufgetreten, der Vorgang kann nicht fortgesetzt werden!\nBitte versuchen Sie es erneut.');
                    })
                    .success(function() {
                        sendMails();
                    });
    }

    $.extend($.fn.disableTextSelect = function() {
        return this.each(function() {
            if ($.browser.mozilla) {//Firefox
                $(this).css('MozUserSelect', 'none');
            } else if ($.browser.msie) {//IE
                $(this).bind('selectstart', function() { return false; });
            } else {//Opera, etc.
                $(this).mousedown(function() { return false; });
            }
        });
    });

    $.extend($.fn.addGradientBg = function(color1, color2) {
        return this.each(function() {
            $(this).css('background', color1)
                .css('filter', 'progid:DXImageTransform.Microsoft.gradient(startColorstr=\'' + color1 + '\', endColorstr=\'' + color2 + '\')') /* for IE */
                .css('background', '-webkit-gradient(linear, left top, left bottom, from(' + color1 + '), to(' + color2 + '))') /* for webkit browsers */
                .css('background', '-moz-linear-gradient(top,  ' + color1 + ',  ' + color2 + ')'); /* for firefox 3.6+ */
        });
    });

    $.extend($.fn.addShadow = function(color) {
        return this.each(function() {
            $(this).css('-webkit-box-shadow', '5px 4px 3px ' + color)
                    .css('-moz-box-shadow', '5px 4px 3px ' + color)
                    .css('box-shadow', '5px 4px 3px ' + color);
        });
    });

    $.extend($.fn.sortElements = function() {

        var sort = [].sort;

        return function(comparator, getSortable) {

            getSortable = getSortable || function() { return this; };

            var placements = this.map(function() {

                var sortElement = getSortable.call(this),
                parentNode = sortElement.parentNode,

                // Since the element itself will change position, we have
                // to have some way of storing its original position in
                // the DOM. The easiest way is to have a 'flag' node:
                nextSibling = parentNode.insertBefore(
                    document.createTextNode(''),
                    sortElement.nextSibling
                );

                return function() {

                    if (parentNode === this) {
                        throw new Error("You can't sort elements if any one is a descendant of another.");
                    }

                    // Insert before flag:
                    parentNode.insertBefore(this, nextSibling);
                    // Remove flag:
                    parentNode.removeChild(nextSibling);

                };

            });

            return sort.call(this, comparator).each(function(i) {
                placements[i].call(getSortable.call(this));
            });

        };
    });
});

var NSL = new function () {

    /* ------------------------- Startseite ------------------------- */
    this.pluginPublication = function (pluginname) {
        $('.plugin[name=' + pluginname + ']').removeClass('red');
        $('.plugin[name=' + pluginname + ']').addClass('green');
    };

    /* ------------------------- PluginArea ------------------------- */
    this.pluginAreaAddApp = function (appName, appCaption) {
        if ($('#pluginAreaMenu').length == 0) return;
        var item = $('<table id="' + appName + '" style="float:left; margin: 5px;"><tr><td>&nbsp;</td><td><h3>' + appCaption + '</h3></td></tr></table>')
            .css('float', 'left')
            .css('padding', 5)
            .css('margin', 5)
            .css('width', 300)
            .css('height', 120)
            .css('border', '1px solid gray')
            .css('-webkit-border-radius', 5)
            .css('-moz-border-radius', 5)
	        .css('border-radius', 5)
            .css('-webkit-box-shadow', '5px 4px 3px #CCCCCC') /* webkit browser*/
            .css('-moz-box-shadow', '5px 4px 3px #CCCCCC') /* firefox */
            .css('box-shadow', '5px 4px 3px #CCCCCC');

        $('#pluginAreaMenu').append(item);

        item.find('td').css('vertical-align', 'top');
        item.find('td:first-child')
            .css('width', 50)
            .css('border-right', '1px dotted gray');
        item.find('h3')
            .css('padding', 0)
            .css('margin', 0)
            .css('margin-bottom', 4)
            .css('border-bottom', '1px solid orange');

        $('#pluginAreaMenu').css('height', item.position().top + item.outerHeight() - 90);
    };

    this.pluginAreaAppAddLink = function (appName, itemName, itemText) {
        if ($('#pluginAreaMenu').length == 0) return;
        if ($('#' + appName).length == 0) return;

        var item = $('<a name="' + itemName + '">' + itemText + '</a><br>')
            .css('cursor', 'pointer');

        $('#' + appName + ' td:last-child').append(item);


        return item;
    };
    this.pluginAreaAppAddText = function (appName, itemText) {
        if ($('#pluginAreaMenu').length == 0) return;
        if ($('#' + appName).length == 0) return;

        var item = $('<span>' + itemText + '</span><br>');

        $('#' + appName + ' td:last-child').append(item);


        return item;
    };

    this.pluginAreaContentAdd = function (content) {
        if ($('#pluginArea').length == 0) return;

        var me = this;
        me.pluginAreaContentClean();
        me.pluginAreaContentAppend(content);
    };

    this.pluginAreaContentAppend = function (content) {
        if ($('#pluginArea').length == 0) return;

        var div = $('<div></div>')
            .addClass('content')
            .css('display', 'none')
            .append($(content))
            .appendTo($('#pluginArea'))
            .fadeIn('fast');
    };
    this.pluginAreaContentPrepend = function (content) {
        if ($('#pluginArea').length == 0) return;

        var div = $('<div></div>')
            .addClass('content')
            .css('display', 'none')
            .prepend($(content))
            .appendTo($('#pluginArea'))
            .fadeIn('fast');
    };
    this.pluginAreaContentClean = function () {
        if ($('#pluginArea').length == 0) return;

        if ($('#pluginArea').children().length > 0) {
            $('#pluginArea').empty().show();
        }
    };


    /* ------------------------- Allgemein ------------------------- */
    this.getMainDirURL = function () {
        var path = window.location.pathname;
        var elems = path.split('/');
        var last = elems[elems.length - 1];
        path = path.replace(last, '');
        if (path.charAt(path.length - 1) == '/') {
            path = path.substr(0, path.length - 1);
        }

        path = "http://" + window.location.hostname + path;
        return path;
    };
    this.getScriptDirURL = function () {
        var url = this.getMainDirURL();
        url = url.replace('protected', '');
        if (url.charAt(url.length - 1) == '/') {
            url = url.substr(0, url.length - 1);
        }

        return url;
    };

    this.alert = function (message) {
        alert(message);
    };

    this.arrayContains = function (a, obj) {
        for (var i = 0; i < a.length; i++) {
            if (a[i] === obj) {
                return true;
            }
        }
        return false;
    }
}
